Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/ExperimentJob.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/ExperimentJob.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/ExperimentJob.cs	(revision 4368)
@@ -0,0 +1,68 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.JobBase;
+using HeuristicLab.Optimization;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Experiment.Properties;
+
+namespace HeuristicLab.Hive.Experiment.Jobs {
+  [StorableClass]
+  public class ExperimentJob : OptimizerJob {
+    [Storable]
+    private ExecutionState executionState = ExecutionState.Stopped;
+
+    public ExperimentJob() {
+      this.ComputeInParallel = true;
+    }
+
+    public ExperimentJob(IOptimizer optimizer) : base(optimizer) {
+      this.ComputeInParallel = true;
+    }
+
+    public override ExecutionState ExecutionState {
+      get {
+        return ComputeInParallel ? executionState : base.ExecutionState;
+      }
+    }
+
+    public override void Start() {
+      if (ComputeInParallel) {
+        executionState = Core.ExecutionState.Started;
+        foreach (IJob child in this.ChildJobs) {
+          OnNewChildJob(child);
+        }
+        executionState = Core.ExecutionState.Paused;
+        OnWaitForChildJobs();
+      } else {
+        base.Start();
+      }
+    }
+
+    public override void Resume(IEnumerable<IJob> childJobs) {
+      executionState = Core.ExecutionState.Started;
+      this.childJobs = new List<IJob>(childJobs);
+      UpdateRuns();
+      executionState = Core.ExecutionState.Stopped;
+      OnJobStopped();
+    }
+
+    private void UpdateRuns() {
+      foreach (OptimizerJob optimizerJob in childJobs.Cast<OptimizerJob>()) {
+        this.optimizer.Runs.AddRange(optimizerJob.Optimizer.Runs);
+      }
+    }
+
+    public void AddChildJob(IJob job) {
+      this.childJobs.Add(job);
+    }
+
+    public override bool IsParallelizable {
+      get { return true; }
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/JobList.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/JobList.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/JobList.cs	(revision 4368)
@@ -0,0 +1,21 @@
+﻿using System;
+using System.Collections.Generic;
+using HeuristicLab.Core;
+using HeuristicLab.Hive.JobBase;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Hive.Experiment.Jobs {
+  [Item("IJob List", "Represents a list of hive jobs.")]
+  [StorableClass]
+  public class JobList : ItemList<IJob> {
+    public JobList() : base() { }
+    public JobList(int capacity) : base(capacity) { }
+    public JobList(IEnumerable<IJob> collection) : base(collection) { }
+
+    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
+      JobItemList clone = (JobItemList)base.Clone(cloner);
+      return clone;
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/OptimizerJob.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/OptimizerJob.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/OptimizerJob.cs	(revision 4368)
@@ -0,0 +1,265 @@
+﻿using System;
+using System.Collections.Generic;
+using HeuristicLab.Core;
+using HeuristicLab.Hive.JobBase;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Hive.Experiment.Jobs {
+  [StorableClass]
+  public class OptimizerJob : IJob {
+    [Storable]
+    protected Guid internalId;
+    public Guid InternalId {
+      get { return internalId; }
+    }
+    
+    [Storable]
+    protected IOptimizer optimizer;
+    public IOptimizer Optimizer {
+      get { return optimizer; }
+      set {
+        if (optimizer != null && value != optimizer) {
+          DeregisterEvents();
+        }
+        optimizer = value;
+        if (optimizer != null) {
+          RegisterEvents();
+        }
+      }
+    }
+
+    [Storable]
+    protected double progress = 0.0;
+
+    [Storable]
+    protected ILog log;
+    public ILog Log {
+      get { return log; }
+    }
+
+    [Storable]
+    protected ICollection<IJob> childJobs;
+    public IEnumerable<IJob> ChildJobs {
+      get { return childJobs; }
+    }
+
+    [Storable]
+    protected bool computeInParallel;
+    public bool ComputeInParallel {
+      get { return computeInParallel; }
+      set { computeInParallel = value; }
+    }
+
+    [Storable]
+    protected int coresNeeded;
+    public int CoresNeeded {
+      get { return coresNeeded; }
+      set { coresNeeded = value; }
+    }
+
+    [Storable]
+    protected int memoryNeeded;
+    public int MemoryNeeded {
+      get { return memoryNeeded; }
+      set { memoryNeeded = value; }
+    }
+
+    public OptimizerJob() {
+      this.internalId = Guid.NewGuid();
+      this.log = new Log();
+      this.childJobs = new List<IJob>();
+      this.ComputeInParallel = false;
+      this.CoresNeeded = 1;
+      this.MemoryNeeded = 0;
+    }
+
+    public OptimizerJob(IOptimizer optimizer)
+      : this() {
+      this.optimizer = optimizer;
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    protected virtual void AfterDeserialization() {
+      RegisterEvents();
+    }
+
+    #region IJob Members
+    
+    public double Progress {
+      get { return optimizer.ExecutionState == ExecutionState.Stopped ? 1.0 : this.progress; }
+    }
+
+    public virtual ExecutionState ExecutionState {
+      get { return optimizer.ExecutionState; }
+    }
+
+    public virtual void Run() {
+      throw new NotSupportedException();
+    }
+
+    public virtual void Prepare() {
+      optimizer.Prepare();
+    }
+
+    public virtual void Start() {
+      optimizer.Start();
+    }
+
+    public virtual void Stop() {
+      optimizer.Stop();
+    }
+
+    public virtual void Resume(IEnumerable<IJob> childJobs) {
+      throw new NotSupportedException();
+    }
+
+    public event EventHandler JobStopped;
+    protected virtual void OnJobStopped() {
+      EventHandler handler = JobStopped;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler JobFailed;
+    protected virtual void OnJobFailed(Common.EventArgs<Exception> e) {
+      EventHandler handler = JobFailed;
+      if (handler != null) handler(this, e);
+    }
+
+    public event EventHandler<Common.EventArgs<IJob>> NewChildJob;
+    protected virtual void OnNewChildJob(IJob job) {
+      EventHandler<Common.EventArgs<IJob>> handler = NewChildJob;
+      if (handler != null) handler(this, new Common.EventArgs<IJob>(job));
+    }
+
+    public event EventHandler WaitForChildJobs;
+    protected virtual void OnWaitForChildJobs() {
+      EventHandler handler = WaitForChildJobs;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    #endregion
+
+    #region Events
+    protected virtual void RegisterEvents() {
+      optimizer.Stopped += new EventHandler(optimizer_Stopped);
+      optimizer.ExceptionOccurred += new EventHandler<Common.EventArgs<Exception>>(optimizer_ExceptionOccurred);
+      optimizer.DescriptionChanged += this.DescriptionChanged;
+      optimizer.FilenameChanged += this.FilenameChanged;
+      optimizer.ItemImageChanged += this.ItemImageChanged;
+      optimizer.NameChanged += this.NameChanged;
+      optimizer.NameChanging += this.NameChanging;
+      optimizer.ToStringChanged += this.ToStringChanged;
+    }
+
+    protected virtual void DeregisterEvents() {
+      optimizer.Stopped -= new EventHandler(optimizer_Stopped);
+      optimizer.ExceptionOccurred -= new EventHandler<Common.EventArgs<Exception>>(optimizer_ExceptionOccurred);
+      optimizer.DescriptionChanged -= this.DescriptionChanged;
+      optimizer.FilenameChanged -= this.FilenameChanged;
+      optimizer.ItemImageChanged -= this.ItemImageChanged;
+      optimizer.NameChanged -= this.NameChanged;
+      optimizer.NameChanging -= this.NameChanging;
+      optimizer.ToStringChanged -= this.ToStringChanged;
+    }
+
+    protected virtual void optimizer_ExceptionOccurred(object sender, Common.EventArgs<Exception> e) {
+      if (optimizer.ExecutionState != ExecutionState.Stopped) this.progress = 0.0;
+      else this.progress = 1.0;
+      OnJobFailed(e);
+    }
+
+    protected virtual void optimizer_Stopped(object sender, EventArgs e) {
+      if (optimizer.ExecutionState != ExecutionState.Stopped) this.progress = 0.0;
+      else this.progress = 1.0;
+      OnJobStopped();
+    }
+    #endregion
+
+
+    #region INamedItem Members
+
+    public bool CanChangeDescription {
+      get { return optimizer.CanChangeDescription; }
+    }
+
+    public bool CanChangeName {
+      get { return optimizer.CanChangeName; }
+    }
+
+    public string Description {
+      get { return optimizer.Description; }
+      set { optimizer.Description = value; }
+    }
+    public event EventHandler DescriptionChanged;
+
+    public string Name {
+      get { return optimizer.Name; }
+      set { optimizer.Name = value; }
+    }
+    public event EventHandler NameChanged;
+    public event EventHandler<Common.CancelEventArgs<string>> NameChanging;
+
+    #endregion
+
+    #region IItem Members
+
+    public string ItemDescription {
+      get { return optimizer.ItemDescription; }
+    }
+
+    public System.Drawing.Image ItemImage {
+      get { return optimizer.ItemImage; }
+    }
+
+    public event EventHandler ItemImageChanged;
+    public string ItemName {
+      get { return optimizer.ItemName; }
+    }
+
+    public Version ItemVersion {
+      get { return optimizer.ItemVersion; }
+    }
+    public event EventHandler ToStringChanged;
+
+    #endregion
+
+    #region IStorableContent Members
+
+    public string Filename {
+      get;
+      set;
+    }
+    public event EventHandler FilenameChanged;
+
+    #endregion
+
+    #region IDeepCloneable Members
+
+    public Common.IDeepCloneable Clone(Common.Cloner cloner) {
+      throw new NotImplementedException();
+    }
+
+    #endregion
+
+    #region ICloneable Members
+
+    public object Clone() {
+      throw new NotImplementedException();
+    }
+
+    #endregion
+
+    /// <summary>
+    /// Gets the string representation of the current instance in the format: <c>Name: [null|Value]</c>.
+    /// </summary>
+    /// <returns>The current instance as a string.</returns>
+    public override string ToString() {
+      return Name;
+    }
+    
+    public virtual bool IsParallelizable {
+      get { return false; }
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs	(revision 4368)
@@ -28,31 +28,38 @@
 using HeuristicLab.Hive.Contracts;
 using HeuristicLab.Hive.Experiment.Properties;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Experiment {
   internal class ServiceLocator {
-    internal static IClientFacade CreateClientFacade(string hostAddress) {
-      ChannelFactory<IClientFacade> factory = new ChannelFactory<IClientFacade>("ClientHttpEndpoint");
-      WcfSettings.SetEndpointAddress(factory.Endpoint, hostAddress);
+    private static ServiceLocator instance = null;
+    private WcfServicePool<IClientFacade> clientFacadePool = null;
+    private WcfServicePool<IClientFacade> streamedClientFacadePool = null;
 
-      factory.Credentials.UserName.UserName = Settings.Default.HiveUsername;
-      factory.Credentials.UserName.Password = Settings.Default.HivePassword;
-
-      IClientFacade client = factory.CreateChannel();
-      return client;
+    internal static ServiceLocator Instance {
+      get {
+        if (instance == null) {
+          instance = new ServiceLocator();
+        }
+        return instance;
+      }
     }
 
-    internal static IClientFacade CreateStreamedClientFacade(string hostAddress) {
-      ChannelFactory<IClientFacade> factory = new ChannelFactory<IClientFacade>("ClientTcpStreamedEndpoint");
-      WcfSettings.SetEndpointAddress(factory.Endpoint, hostAddress);
-
-      factory.Credentials.UserName.UserName = Settings.Default.HiveUsername;
-      factory.Credentials.UserName.Password = Settings.Default.HivePassword;
-
-      IClientFacade client = factory.CreateChannel();
-      return client;
+    internal WcfServicePool<IClientFacade> ClientFacadePool {
+      get {
+        if (clientFacadePool == null) {
+          clientFacadePool = new WcfServicePool<IClientFacade>(Settings.Default.HiveServerIp, Settings.Default.HiveUsername, Settings.Default.HivePassword, "ClientHttpEndpoint");
+        }
+        return clientFacadePool;
+      }
     }
 
-    public static void DisposeClientFacade(IClientFacade clientFacade) {
-      WcfSettings.DisposeWcfClient((ICommunicationObject)clientFacade);      
+    internal WcfServicePool<IClientFacade> StreamedClientFacadePool {
+      get {
+        if (streamedClientFacadePool == null) {
+          streamedClientFacadePool = new WcfServicePool<IClientFacade>(Settings.Default.HiveServerIp, Settings.Default.HiveUsername, Settings.Default.HivePassword, "ClientTcpStreamedEndpoint");
+        }
+        return streamedClientFacadePool;
+      }
     }
   }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/HeuristicLab.Hive.JobBase-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/HeuristicLab.Hive.JobBase-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/HeuristicLab.Hive.JobBase-3.3.csproj	(revision 4368)
@@ -91,4 +91,5 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Core-3.3">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Core-3.3.dll</HintPath>
@@ -116,4 +117,5 @@
     <Compile Include="Interfaces\IJob.cs" />
     <Compile Include="HeuristicLabHiveJobBasePlugin.cs" />
+    <Compile Include="PluginUtil.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs	(revision 4368)
@@ -2,18 +2,57 @@
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System.Collections.Generic;
 
 namespace HeuristicLab.Hive.JobBase {
-  public interface IJob {
-    long JobId { get; set; }
+  public interface IJob : INamedItem {
+    /// <summary>
+    /// This ID is needed to identify the object when it returns from hive
+    /// </summary>
+    Guid InternalId { get; }
+
     ExecutionState ExecutionState { get; }
+    IEnumerable<IJob> ChildJobs { get; }
     double Progress { get; }
+    ILog Log { get; }
 
+    /// <summary>
+    /// indicates wether it is possible to create childjobs from this job
+    /// </summary>
+    bool IsParallelizable { get; }
+
+    /// <summary>
+    /// Configuration to indicate if this job should create child-jobs which will be executed in hive
+    /// Cannot be set true if IsParallelizable is false
+    /// </summary>
+    bool ComputeInParallel { get; set; }
+
+    /// <summary>
+    /// Gets or sets the cores that will be needed by this job
+    /// </summary>
+    int CoresNeeded { get; set; }
+
+    /// <summary>
+    /// Gets or sets the memory that will be consumed by this job
+    /// </summary>
+    int MemoryNeeded { get; set; }
+    
     void Run();
     void Prepare();
     void Start();
     void Stop();
+    void Resume(IEnumerable<IJob> childJobs);
 
     event EventHandler JobStopped;
     event EventHandler JobFailed;
+
+    /// <summary>
+    /// When this event occurs the job wants to sleep until all his child jobs are finished
+    /// </summary>
+    event EventHandler WaitForChildJobs;
+
+    /// <summary>
+    /// This event will be thrown when the job wants to have a child-job to be computed
+    /// </summary>
+    event EventHandler<Common.EventArgs<IJob>> NewChildJob;
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/PluginUtil.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/PluginUtil.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/PluginUtil.cs	(revision 4368)
@@ -0,0 +1,96 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Reflection;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Hive.JobBase {
+  public static class PluginUtil {
+    #region Required Plugin Search
+    
+    /// <summary>
+    /// Returns a list of plugins in which the type itself and all members 
+    /// of the type are declared. Objectgraph is searched recursively.
+    /// </summary>
+    public static IEnumerable<IPluginDescription> GetDeclaringPlugins(Type type) {
+      HashSet<Type> types = new HashSet<Type>();
+      FindTypes(type, types, "HeuristicLab.");
+      return GetDeclaringPlugins(types);
+    }
+
+    /// <summary>
+    /// Returns the plugins (including dependencies) in which the given types are declared
+    /// </summary>
+    public static IEnumerable<IPluginDescription> GetDeclaringPlugins(IEnumerable<Type> types) {
+      HashSet<IPluginDescription> plugins = new HashSet<IPluginDescription>();
+      foreach (Type t in types) {
+        FindDeclaringPlugins(ApplicationManager.Manager.GetDeclaringPlugin(t), plugins);
+      }
+      return plugins;
+    }
+
+    /// <summary>
+    /// Finds the dependencies of the given plugin and adds it to the plugins hashset.
+    /// Also searches the dependencies recursively.
+    /// </summary>
+    public static void FindDeclaringPlugins(IPluginDescription plugin, HashSet<IPluginDescription> plugins) {
+      if (!plugins.Contains(plugin)) {
+        plugins.Add(plugin);
+        foreach (IPluginDescription dependency in plugin.Dependencies) {
+          FindDeclaringPlugins(dependency, plugins);
+        }
+      }
+    }
+
+    /// <summary>
+    /// Recursively finds all types used in type which are in a namespace which starts with namespaceStart
+    /// Be aware that search is not performed on attributes
+    /// </summary>
+    /// <param name="type">the type to be searched</param>
+    /// <param name="types">found types will be stored there, needed in order to avoid duplicates</param>
+    /// <param name="namespaceStart">only types from namespaces which start with this will be searched and added</param>
+    public static void FindTypes(Type type, HashSet<Type> types, string namespaceStart) {
+      if (!types.Contains(type) && type.Namespace.StartsWith(namespaceStart)) {
+        types.Add(type);
+
+        // constructors
+        foreach (ConstructorInfo info in type.GetConstructors()) {
+          foreach (ParameterInfo paramInfo in info.GetParameters()) {
+            FindTypes(paramInfo.ParameterType, types, namespaceStart);
+          }
+        }
+
+        // interfaces
+        foreach (Type t in type.GetInterfaces()) {
+          FindTypes(t, types, namespaceStart);
+        }
+
+        // events
+        foreach (EventInfo info in type.GetEvents()) {
+          FindTypes(info.EventHandlerType, types, namespaceStart);
+          FindTypes(info.DeclaringType, types, namespaceStart);
+        }
+
+        // properties
+        foreach (PropertyInfo info in type.GetProperties()) {
+          FindTypes(info.PropertyType, types, namespaceStart);
+        }
+
+        // fields
+        foreach (FieldInfo info in type.GetFields()) {
+          FindTypes(info.FieldType, types, namespaceStart);
+        }
+
+        // methods
+        foreach (MethodInfo info in type.GetMethods()) {
+          foreach (ParameterInfo paramInfo in info.GetParameters()) {
+            FindTypes(paramInfo.ParameterType, types, namespaceStart);
+          }
+          FindTypes(info.ReturnType, types, namespaceStart);
+        }
+      }
+    }
+    #endregion
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Authorization/AuthorizationManager.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Authorization/AuthorizationManager.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Authorization/AuthorizationManager.cs	(revision 4368)
@@ -9,25 +9,24 @@
 using HeuristicLab.Hive.Server.DataAccess;
 using HeuristicLab.Hive.Server.Core.InternalInterfaces;
+using System.Web.Security;
 
 namespace HeuristicLab.Hive.Server.Core.Authorization {
   public class AuthorizationManager : IAuthorizationManager {
-    private IContextFactory contextFactory = ServiceLocator.GetContextFactory();
+    private MembershipUser Identity {
+      get { return Membership.GetUser(); }
+    }
+
+    public Guid UserId {
+      get { return (Guid)Identity.ProviderUserKey; }
+    }
 
     public void AuthorizeForJobs(params Guid[] jobIds) {
-      if (!(Identity.IsAuthenticated && IsAuthorizedForJobs(jobIds))) {
-        throw new SecurityException("User '" + Identity.Name + "' is not authorized to access job (Id: " + string.Join(", ", jobIds.Select(x => x.ToString()).ToArray()) + ")");
+      if (!IsAuthorizedForJobs(jobIds)) {
+        throw new SecurityException("User '" + Identity.UserName + "' is not authorized to access job (Id: " + string.Join(", ", jobIds.Select(x => x.ToString()).ToArray()) + ")");
       }
-    }
-
-    public string UserId {
-      get { return Identity.Name; }
     }
     
     private bool IsAuthorizedForJobs(params Guid[] jobIds) {
-      return DaoLocator.JobDao.IsUserAuthorizedForJobs(Identity.Name, jobIds);
-    }
-
-    private IIdentity Identity {
-      get { return ServiceSecurityContext.Current.PrimaryIdentity; }
+      return DaoLocator.JobDao.IsUserAuthorizedForJobs(UserId, jobIds);
     }
   }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs	(revision 4368)
@@ -21,6 +21,7 @@
 
     public bool ExistsJobForSlave(HeartBeatData hbData) {
-      List<JobDto> allOfflineJobsForSlave = new List<JobDto>(DaoLocator.JobDao.FindFittingJobsForSlave(JobState.Offline, hbData.FreeCores, hbData.FreeMemory, hbData.SlaveId));
-      return (allOfflineJobsForSlave != null && allOfflineJobsForSlave.Count > 0);
+      return 
+        DaoLocator.JobDao.FindJobsWithFinishedChilds(hbData.SlaveId).Count() > 0 || 
+        DaoLocator.JobDao.FindFittingJobs(JobState.Offline, hbData.FreeCores, hbData.FreeMemory, hbData.SlaveId).Count() > 0;
     }
 
@@ -31,15 +32,16 @@
         using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
           SlaveDto slave = DaoLocator.SlaveDao.FindById(slaveId);
+
           if (slave != null) {
-            LinkedList<JobDto> allOfflineJobsForSlave = new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobsForSlave(JobState.Offline, slave.NrOfFreeCores, slave.FreeMemory, slave.Id));
-            if (allOfflineJobsForSlave != null && allOfflineJobsForSlave.Count > 0) {
-              jobToCalculate = allOfflineJobsForSlave.First.Value;
-              jobToCalculate.State = JobState.Calculating;
-              jobToCalculate.Slave = slave;
-              jobToCalculate.Slave.State = SlaveState.Calculating;
-              jobToCalculate.DateCalculated = DateTime.Now;
-              DaoLocator.JobDao.AssignSlaveToJob(slave.Id, jobToCalculate.Id);
-              DaoLocator.JobDao.Update(jobToCalculate);
-              DaoLocator.SlaveDao.Update(jobToCalculate.Slave);
+            LinkedList<JobDto> finishedJobsForSlave = new LinkedList<JobDto>(DaoLocator.JobDao.FindJobsWithFinishedChilds(slave.Id));
+            if (finishedJobsForSlave != null && finishedJobsForSlave.Count > 0) {
+              jobToCalculate = finishedJobsForSlave.First.Value;
+              UpdateJobAsCalculating(jobToCalculate, slave);
+            }
+
+            LinkedList<JobDto> offlineJobsForSlave = new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobs(JobState.Offline, slave.NrOfFreeCores, slave.FreeMemory, slave.Id));
+            if (offlineJobsForSlave != null && offlineJobsForSlave.Count > 0) {
+              jobToCalculate = offlineJobsForSlave.First.Value;
+              UpdateJobAsCalculating(jobToCalculate, slave);
             }
           }
@@ -52,4 +54,14 @@
     }
 
+    private static void UpdateJobAsCalculating(JobDto jobToCalculate, SlaveDto slave) {
+      jobToCalculate.State = JobState.Calculating;
+      jobToCalculate.Slave = slave;
+      jobToCalculate.Slave.State = SlaveState.Calculating;
+      jobToCalculate.DateCalculated = DateTime.Now;
+      DaoLocator.JobDao.AssignSlaveToJob(slave.Id, jobToCalculate.Id);
+      DaoLocator.JobDao.Update(jobToCalculate);
+      DaoLocator.SlaveDao.Update(jobToCalculate.Slave);
+    }
+
     #endregion
   }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4368)
@@ -69,8 +69,17 @@
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
-    public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested, bool snapshot) {
+    public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId) {
       using (contextFactory.GetContext(false)) {
         ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
-        return jobManager.GetLastSerializedResult(jobId, requested, snapshot);
+        return jobManager.GetLastSerializedResult(jobId);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
+    public ResponseObject<SerializedJob> GetSnapshotResult(Guid jobId) {
+      using (contextFactory.GetContext(false)) {
+        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
+        return jobManager.GetSnapshotResult(jobId);
       }
     }
@@ -103,5 +112,18 @@
     }
 
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
+    public ResponseObject<JobResultList> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent) {
+      using (contextFactory.GetContext(false)) {
+        if (parentJobId.HasValue) {
+          ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(parentJobId.Value);
+        } 
+        // If parentJobId is null, GetChildJobResults will filter the results for the current user
+        return jobManager.GetChildJobResults(parentJobId, recursive, includeParent);
+      }
+    }
     #endregion
+
+
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4368)
@@ -32,4 +32,5 @@
 using HeuristicLab.Hive.Contracts.ResponseObjects;
 using System.Security.Permissions;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -46,4 +47,5 @@
     }
 
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
     public Response Login() {
       Response resp = new Response();
@@ -129,7 +131,14 @@
 
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
-    public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested, bool snapshot) {
-      using (contextFactory.GetContext(false)) {
-        return jobManager.GetLastSerializedResult(jobId, requested, snapshot);
+    public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId) {
+      using (contextFactory.GetContext(false)) {
+        return jobManager.GetLastSerializedResult(jobId);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    public ResponseObject<SerializedJob> GetSnapshotResult(Guid jobId) {
+      using (contextFactory.GetContext(false)) {
+        return jobManager.GetSnapshotResult(jobId);
       }
     }
@@ -223,4 +232,25 @@
       using (contextFactory.GetContext()) {
         return jobManager.AddJobWithGroupStrings(job, resources);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    public ResponseObject<JobResultList> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent) {
+      using (contextFactory.GetContext()) {
+        return jobManager.GetChildJobResults(parentJobId, recursive, includeParent);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    public ResponseObject<JobDto> AddChildJob(Guid parentJobId, SerializedJob serializedJob) {
+      using (contextFactory.GetContext()) {
+        return jobManager.AddChildJob(parentJobId, serializedJob);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    public ResponseObject<JobDto> PauseJob(SerializedJob serializedJob) {
+      using (contextFactory.GetContext()) {
+        return jobManager.PauseJob(serializedJob);
       }
     }
